﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using Telerik.DesignTemplates.WP.ViewModels;

namespace Telerik.DesignTemplates.WP.Templates.Conversations
{
    public partial class ConversationView02 : UserControl
    {
        public ConversationView02()
        {
            this.Loaded += ConversationView02_Loaded;
            InitializeComponent();
            this.SetConversationParticipants();
            this.SetGroupDescriptors();
        }

        void ConversationView02_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    //this.conversationView.BringIntoView((this.DataContext as MessagesViewModel).Messages.First());
                    this.conversationView.BringIntoView((this.DataContext as MessagesViewModel).Messages.Last());
                });
        }

        private void OnSendingMessage(object sender, ConversationViewMessageEventArgs e)
        {
            if (string.IsNullOrEmpty((e.Message as ConversationViewMessage).Text))
            {
                return;
            }
            ConversationViewMessage originalMessage = e.Message as ConversationViewMessage;
            MessagesViewModel viewModel = this.DataContext as MessagesViewModel;
            CustomMessage previousMessage = viewModel.Messages.Last();
            int group = previousMessage.Group.GroupId.HasValue ? previousMessage.Group.GroupId.Value : 0;
            if (previousMessage.SenderId != viewModel.You.PersonId)
            {
                group++;
            }
            CustomMessage customMessage = new CustomMessage(originalMessage.Text, originalMessage.TimeStamp, originalMessage.Type, viewModel.You.PersonId, group);
            viewModel.Messages.Add(customMessage);
        }

        private void SetConversationParticipants()
        {
            MessagesViewModel viewModel = this.DataContext as MessagesViewModel;
            viewModel.ConversationBuddy = viewModel.People[0];
            viewModel.You = viewModel.People[4];
        }

        private void SetGroupDescriptors()
        {
            this.conversationView.GroupDescriptors = new DataDescriptor[] 
            { 
                new GenericGroupDescriptor<CustomMessage, int?>(message => message.Group.GroupId)
            };
        }
    }
}
